<?php
/**
*
* Copyright (C) 2011 Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
*
* This program is free software; you can redistribute it and/or modify it under
* the terms of the GNU Affero General Public License version 3 as published by
* the Free Software Foundation with the addition of the following permission
* added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
* WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
* WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
*
* This program is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
* FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
* details.
*
* You should have received a copy of the GNU Affero General Public License
* along with this program; if not, see www.gnu.org/licenses or write to
* the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
* MA 02110-1301 USA.
*
* This code is based on the OpenXchange Connector and on the Prognus pSync
* Connector both developed by the community and licensed under the GPL
* version 2 or above as published by the Free Software Foundation.
*
* You can contact Prognus Software Livre headquarters at Av. Tancredo Neves,
* 6731, PTI, Bl. 05, Esp. 02, Sl. 10, Foz do Iguau - PR - Brasil or at
* e-mail address prognus@prognus.com.br.
*
* Servio de email
*
* @package    Services
* @license    http://www.gnu.org/copyleft/gpl.html GPL
* @author     Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
* @version    1.0
* @sponsor    Caixa Econmica Federal
*/


if( !function_exists( 'zend_include' ) )
{
    function zend_include( $path )
    {
	set_include_path( LIBRARY );
	require_once( $path );
	restore_include_path();
    }
}


zend_include( 'Zend/Mail.php' );


/**
* Servio de email
*
* Classe responsvel pelas operaes de email
*
* @package    Service
* @license    http://www.gnu.org/copyleft/gpl.html GPL
* @author     Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
* @sponsor    Caixa Econmica Federal
* @version    1.0
*/
class MailService extends Zend_Mail /*implements ConfigurationService, HookableService*/
{
    static $configuration = array( 'host' => '', 'port' => '', 'username' => '', 'password' => '' );

    
	/**
     * Construtor da classe
     *
     * @license    http://www.gnu.org/copyleft/gpl.html GPL
     * @author     Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
	 * @sponsor   Caixa Econmica Federal
     * @param string $config
     */
	public function __construct( $config = null)
    {
		if( !$config )
		{
			require_once ( ROOT.'/header.inc.php' );
	
			$boemailadmin = CreateObject('emailadmin.bo');
			$emailadmin = $boemailadmin->getProfileList();
			$emailadmin = $boemailadmin->getProfile($emailadmin[0]['profileID']);
			
			self::$configuration['host'] = $emailadmin['smtpServer'];
			self::$configuration['port'] = $emailadmin['smtpPort'];
	
		// 	    self::$configuration['username'] = $emailadmin['user'];
		// 	    self::$configuration['password'] = $emailadmin['pass'];
		// 	    self::$configuration['name'] = $emailadmin['name'];
		// 	    self::$configuration['type'] = 'SMTP';
	
		// 	    array_merge( $configuration, array( 'auth' => 'login' ) );
		
			zend_include( 'Zend/Mail/Transport/Smtp.php' );
				zend_include( 'Zend/Mail/Part.php' );
			set_include_path(LIBRARY);
			parent::setDefaultTransport( new Zend_Mail_Transport_Smtp( self::$configuration['host'], self::$configuration ) );
			restore_include_path();
		}
	
		else
			$this->configure( $config );
    }

    
	/**
     * Mtodo que envia a mensagem
     *
     * @license    http://www.gnu.org/copyleft/gpl.html GPL
     * @author     Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
	 * @sponsor    Caixa Econmica Federal
     * @param string $to
     * @param string $from
     * @param string $subject
     * @param string $body
     * @param string $bcc
     * @param string $cc
     * @param string $isHTML
     */
	public function send( $to, $from, $subject, $body, $bcc = null, $cc = null, $isHTML = true )
    {
        set_include_path( LIBRARY );
		if( $body )
		{
			if( $isHTML )
			parent::setBodyHtml( $body );
	
			else
			parent::setBodyText( $body );
		}
	
		if( $subject )
			parent::setSubject( $subject );
		
		if( !$from )
			$from = $GLOBALS['phpgw']->preferences->values['email'];
	
		parent::setFrom( $from, self::getNameByMail( $from ) );
	
		//pra nao ter que fazer os ifs acima...
		$destTypes = array( 'to', 'bcc', 'cc' );
	
		foreach( $destTypes as $destination )
		{
			$dest = $$destination;
		
			if( $dest )
			{
				if( !is_array( $dest ) )
					$dest = array( $dest );
	
				foreach( $dest as $d )
				{
					$addDestination = 'add'.ucfirst($destination);
		
					parent::$addDestination( $d, self::getNameByMail( $d ) );
				}
			}
		}
	
		parent::send();
		restore_include_path();
    }

   
	/**
     * Mtodo de configurao
     *
     * @license    http://www.gnu.org/copyleft/gpl.html GPL
     * @author     Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
	 * @sponsor    Caixa Econmica Federal
     * @param string $config
     */
	public function configure( $config )
    {
		if( !$config ) return( false );
	
		foreach( $config as $key => $value )
		{
			if( $value && isset( self::$configuration[$key] ) )
			{
			self::$configuration[$key] = $value;
			}
		}
    }

    //hook
    public function getNameByMail( $mail )
    {
		return( null );
    }

    public function getAttachment( $attachment )
    {
		return( null );
    }

     /**
     * Adds attachment to the mail message
     *
     * @param string $file  binary file
     * @param string $filename file name
     * @param string $type type example: image/gif
     * @param Zend_Mime $disposition example: Zend_Mime::DISPOSITION_INLINE
     * @param Zend_Mime $encoding example: Zend_Mime::ENCODING_BASE64
     * @return bool
     */
    public function  addAttachment($file, $filename, $type, $encoding = null, $disposition = 'DISPOSITION_ATTACHMENT')
    {
        $part = new Zend_Mime_Part( $file );

        $part->type = $type;
        $part->filename = $filename;

       switch ($disposition)
       {
            case 'DISPOSITION_INLINE':
                $part->disposition = Zend_Mime::DISPOSITION_INLINE;
                break;
            case 'DISPOSITION_ATTACHMENT':
                $part->disposition = Zend_Mime::DISPOSITION_ATTACHMENT;
                break;
            default:  
                break;
        }
        
        switch ($encoding)
        {
            case 'ENCODING_7BIT':
                $part->encoding = Zend_Mime::ENCODING_7BIT;
                break;
            case 'ENCODING_8BIT:':
                $part->encoding = Zend_Mime::ENCODING_8BIT;
                break;
            case 'ENCODING_QUOTEDPRINTABLE:':
                $part->encoding = Zend_Mime::ENCODING_QUOTEDPRINTABLE;
                break;
            default:
                $part->encoding = Zend_Mime::ENCODING_BASE64;
                break;
        }

        parent::addAttachment( $part );

        return;
    }
}

ServiceLocator::register( 'mail', new MailService() );

